CC      ?= $(CROSS_COMPILE)gcc
LD      ?= $(CROSS_COMPILE)ld
AR      ?= $(CROSS_COMPILE)ar
NM      ?= $(CROSS_COMPILE)nm
OBJCOPY ?= $(CROSS_COMPILE)objcopy
OBJDUMP ?= $(CROSS_COMPILE)objdump
READELF ?= $(CROSS_COMPILE)readelf

OUTPUT_DIR ?= build

OTP_OBJS = ${OUTPUT_DIR}/optee_otp.o ${OUTPUT_DIR}/common.o
FIOVB_OBJS = ${OUTPUT_DIR}/optee_fiovb.o ${OUTPUT_DIR}/common.o

CFLAGS += -Wall -I../ta/include -I./include -I.
CFLAGS += -I$(TEEC_EXPORT)/include
LDADD += -lteec -L$(TEEC_EXPORT)/lib

.PHONY: all
all: ${OUTPUT_DIR}/optee_otp ${OUTPUT_DIR}/optee_fiovb

${OUTPUT_DIR}:
	mkdir -p $@

${OUTPUT_DIR}/optee_otp: $(OTP_OBJS)
	$(CC) $(LDFLAGS) -o $@ $^ $(LDADD)

${OUTPUT_DIR}/optee_fiovb: $(FIOVB_OBJS)
	$(CC) $(LDFLAGS) -o $@ $^ $(LDADD)

.PHONY: clean
clean:
	rm -r -f ${OUTPUT_DIR}

${OUTPUT_DIR}/%.o: %.c ${OUTPUT_DIR}
	$(CC) $(CFLAGS) -c $< -o $@
